//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%47EA508A02D2.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%47EA508A02D2.cm

//## begin module%47EA508A02D2.cp preserve=no
//## end module%47EA508A02D2.cp

//## Module: AbstractExpression%47EA508A02D2; Package specification
//## Subsystem: XSUtil::Parse%3E8C4EAA02A6
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Parse/AbstractExpression.h

#ifndef ABSTRACTEXPRESSION_H
#define ABSTRACTEXPRESSION_H 1

//## begin module%47EA508A02D2.additionalIncludes preserve=no
//## end module%47EA508A02D2.additionalIncludes

//## begin module%47EA508A02D2.includes preserve=yes
#include <xsTypes.h>
//## end module%47EA508A02D2.includes

// Error
#include <XSUtil/Error/Error.h>
//## begin module%47EA508A02D2.declarations preserve=no
//## end module%47EA508A02D2.declarations

//## begin module%47EA508A02D2.additionalDeclarations preserve=yes
//## end module%47EA508A02D2.additionalDeclarations


//## begin AbstractExpression%47EA51B301FC.preface preserve=yes
//## end AbstractExpression%47EA51B301FC.preface

//## Class: AbstractExpression%47EA51B301FC
//	Abstract base class for Expression subclasses.  This
//	is meant to take care of only the most generic and
//	context-free parsing tasks (a category somewhat open to
//	interpretation).  For example it makes no distinction
//	between numbers and letters.  Both are grouped under the
//	WordExp token type.  It is also unaware that some words
//	may be mathematical functions, or that Xspec model
//	expressions may have more limiting rules.  One exception
//	to the generality is for "{}" chars, for which it uses
//	some knowledge of table model expression syntax.
//## Category: XSUtil::Parse%36939CA6F48B
//## Subsystem: XSUtil::Parse%3E8C4EAA02A6
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class AbstractExpression 
{
  //## begin AbstractExpression%47EA51B301FC.initialDeclarations preserve=yes
  //## end AbstractExpression%47EA51B301FC.initialDeclarations

  public:
    //## Class: AbstractExpressionError%47EAB2A10353
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class AbstractExpressionError : public YellowAlert  //## Inherits: <unnamed>%47EAB3C8021A
    {
      public:
        //## Constructors (specified)
          //## Operation: AbstractExpressionError%47EAB42403A8
          AbstractExpressionError (const string& errMsg);

      protected:
      private:
      private: //## implementation
    };

    //## begin AbstractExpression::Token%47EABAF50309.preface preserve=yes
    //## end AbstractExpression::Token%47EABAF50309.preface

    //## Class: Token%47EABAF50309
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef enum {Null, WordExp, Lbrace, Rbrace, Plus, Minus, Star, Slash, Exp, Lcurl, Rcurl, Comma} Token;

    //## begin AbstractExpression::Token%47EABAF50309.postscript preserve=yes
    //## end AbstractExpression::Token%47EABAF50309.postscript

    //## Class: TokenType%47EABE9700EB
    //	Token class that gives information of the type and
    //	location of the various elements in the Abstract
    //	Expression
    //
    //	type  - Token enum value
    //	location - location in the string
    //	tokenString - corresponding char symbol(s)
    //
    //	Thus if the string is:
    //	a(b+c*d)
    //	01234567
    //	the Token entry for the character c is (WordExp,4,"c")
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    struct TokenType 
    {
        //## Constructors (specified)
          //## Operation: TokenType%47EAC1ED01C4
          TokenType (AbstractExpression::Token type_, size_t loc, string charToken);

        // Data Members for Class Attributes

          //## Attribute: type%47EABFC503D2
          //## begin AbstractExpression::TokenType::type%47EABFC503D2.attr preserve=no  public: AbstractExpression::Token {U} 
          AbstractExpression::Token type;
          //## end AbstractExpression::TokenType::type%47EABFC503D2.attr

          //## Attribute: location%47EABFCF0208
          //## begin AbstractExpression::TokenType::location%47EABFCF0208.attr preserve=no  public: size_t {U} 
          size_t location;
          //## end AbstractExpression::TokenType::location%47EABFCF0208.attr

          //## Attribute: tokenString%47EABFD800CD
          //## begin AbstractExpression::TokenType::tokenString%47EABFD800CD.attr preserve=no  public: string {U} 
          string tokenString;
          //## end AbstractExpression::TokenType::tokenString%47EABFD800CD.attr

      public:
      protected:
      private:
      private: //## implementation
    };

    //## Destructor (generated)
      virtual ~AbstractExpression();


    //## Other Operations (specified)
      //## Operation: init%4815DFAE0375
      virtual void init (const string& exprString, bool removeWhitespace = true);

      //## Operation: clone%47EA620C0390
      virtual AbstractExpression* clone () const = 0;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: WS%47ED532B0249
      static const string& WS ();

      //## Attribute: exprString%47EA631500E2
      const string& exprString () const;

      //## Attribute: tokenList%47EAC4B103C9
      const std::vector<AbstractExpression::TokenType>& tokenList () const;

  public:
    // Additional Public Declarations
      //## begin AbstractExpression%47EA51B301FC.public preserve=yes
      //## end AbstractExpression%47EA51B301FC.public

  protected:
    //## Constructors (generated)
      AbstractExpression();

      AbstractExpression(const AbstractExpression &right);


    //## Other Operations (specified)
      //## Operation: operator==%48359CE40316
      bool operator == (const AbstractExpression& right) const;

      //## Operation: Swap%47EA921802C8
      void Swap (AbstractExpression& right);

      //## Operation: setExprString%482B34600057
      void setExprString (const string& exprString);

      //## Operation: tokenList%483EC761034A
      void tokenList (const std::vector<AbstractExpression::TokenType>& value);

      //## Operation: findTheNumbers%4852B7BB03A6
      //	OK, this does make a distinction between letters and
      //	numbers, but its results aren't stored in this base
      //	class.  This is a helper function for inheriting classes
      //	which need to recognize when an 'e' and a Minus token
      //	may be part of a number.   Its two vector arguments are
      //	filled in with 1: the indices of all Tokens which are
      //	NOT part of a number, and 2: the values of all the found
      //	numbers in left to right order.
      void findTheNumbers (std::vector<size_t>& remainingNonNumbers, std::vector<Real>& values) const;

    // Additional Protected Declarations
      //## begin AbstractExpression%47EA51B301FC.protected preserve=yes
      //## end AbstractExpression%47EA51B301FC.protected

  private:
    //## Assignment Operation (generated)
      AbstractExpression & operator=(const AbstractExpression &right);


    //## Other Operations (specified)
      //## Operation: allValidChars%47ED33150365
      //	This function is non-static in order to make it virtual.
      virtual const string& allValidChars () const = 0;

      //## Operation: determineToken%47ED47D50394
      //	Should this be virtual?  A subclass may want to change
      //	the way symbols are categorized into Tokens.
      virtual AbstractExpression::Token determineToken (string::size_type* pPos) const;

      //## Operation: standardizeExponentOp%47EAB0A500DA
      void standardizeExponentOp ();

      //## Operation: checkBalance%47EAB1BC00F2
      void checkBalance () const;

      //## Operation: removeStarParenCombo%47EAB93102F9
      void removeStarParenCombo ();

      //## Operation: verifyAllChars%47ED397D028D
      //	Meant to be one of the very first parsing stages, this
      //	will throw if it finds any char not among those in all
      //	ValidChars
      void verifyAllChars () const;

      //## Operation: makeTokenList%47ED3E31016B
      void makeTokenList ();

      //## Operation: checkTokenSequence%47F10F9D01F7
      void checkTokenSequence () const;

      //## Operation: removeAllWhitespace%47FF83AD0054
      void removeAllWhitespace ();

      //## Operation: killRedundantParen%482B2F38039B
      //	This is called during init.  The default (base class)
      //	version does nothing.  Leave the definition of
      //	redundancy to inheriting classes, assuming they want to
      //	do anything.
      virtual void killRedundantParen (const string::size_type startPos, const string::size_type endPos);

      //## Operation: isNonExpFloat%4852B9F60224
      //	Needed by findTheNumbers, determine whether testStr
      //	consists only of digits, with an optional single decimal
      //	point at an arbitrary place.  If function returns false,
      //	*value will not be modified.
      static bool isNonExpFloat (const string& testStr, Real* value);

    // Additional Private Declarations
      //## begin AbstractExpression%47EA51B301FC.private preserve=yes
      //## end AbstractExpression%47EA51B301FC.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin AbstractExpression::WS%47ED532B0249.attr preserve=no  public: static string {UC} string(" \t\r\n")
      static const string s_WS;
      //## end AbstractExpression::WS%47ED532B0249.attr

      //## begin AbstractExpression::exprString%47EA631500E2.attr preserve=no  public: string {U} 
      string m_exprString;
      //## end AbstractExpression::exprString%47EA631500E2.attr

      //## begin AbstractExpression::tokenList%47EAC4B103C9.attr preserve=no  public: std::vector<AbstractExpression::TokenType> {U} 
      std::vector<AbstractExpression::TokenType> m_tokenList;
      //## end AbstractExpression::tokenList%47EAC4B103C9.attr

    // Additional Implementation Declarations
      //## begin AbstractExpression%47EA51B301FC.implementation preserve=yes
      static const bool s_legalTokenSequences[][11];
      //## end AbstractExpression%47EA51B301FC.implementation
};

//## begin AbstractExpression%47EA51B301FC.postscript preserve=yes
//## end AbstractExpression%47EA51B301FC.postscript

// Class AbstractExpression::AbstractExpressionError 

// Class AbstractExpression::TokenType 

// Class AbstractExpression 


//## Other Operations (inline)
inline void AbstractExpression::setExprString (const string& exprString)
{
  //## begin AbstractExpression::setExprString%482B34600057.body preserve=yes
  m_exprString = exprString;
  //## end AbstractExpression::setExprString%482B34600057.body
}

inline void AbstractExpression::tokenList (const std::vector<AbstractExpression::TokenType>& value)
{
  //## begin AbstractExpression::tokenList%483EC761034A.body preserve=yes
  m_tokenList = value;
  //## end AbstractExpression::tokenList%483EC761034A.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const string& AbstractExpression::WS ()
{
  //## begin AbstractExpression::WS%47ED532B0249.get preserve=no
  return s_WS;
  //## end AbstractExpression::WS%47ED532B0249.get
}

inline const string& AbstractExpression::exprString () const
{
  //## begin AbstractExpression::exprString%47EA631500E2.get preserve=no
  return m_exprString;
  //## end AbstractExpression::exprString%47EA631500E2.get
}

inline const std::vector<AbstractExpression::TokenType>& AbstractExpression::tokenList () const
{
  //## begin AbstractExpression::tokenList%47EAC4B103C9.get preserve=no
  return m_tokenList;
  //## end AbstractExpression::tokenList%47EAC4B103C9.get
}

//## begin module%47EA508A02D2.epilog preserve=yes
//## end module%47EA508A02D2.epilog


#endif
